function urltablock_checkurl(url) {
	var lockurls = urltablock_getPrefValue("skz.urltablock.autolockurls").split("\n");
	for(var i=0; i<lockurls.length; i++){
		var regex = new RegExp("^" + lockurls[i] + "$");
		if(url.match(regex)) {
			return true;
		}
	}
	return false;
}

function urltablock_load(evt) {
	var tabs = gBrowser.tabContainer;
	for(var i=0; i<tabs.childNodes.length; i++){
		var tab = tabs.childNodes[i];
		if(urltablock_checkurl(gBrowser.getBrowserForTab(tab).currentURI.spec)){
			if(urltablock_getPrefValue("skz.urltablock.tablock")){
				tab.setAttribute('locked', 'true');
			}
			if(urltablock_getPrefValue("skz.urltablock.tabprotect")){
				tab.setAttribute('protected', 'true');
			}
		}
	}
}

function urltablock_add() {
	var url = gBrowser.getBrowserForTab(gBrowser.mContextTab).currentURI.spec;
	url = url.replace(/([\\\.\*\?\+\[\]\{\}\^\$\(\)])/g, "\\$1");
	urltablock_setPrefValue("skz.urltablock.autolockurls",
		url + "\n" +
		urltablock_getPrefValue("skz.urltablock.autolockurls")
	);
	window.openDialog("chrome://urltablock/content/settings.xul");
}

function urltablock_addMenuItem(menuid) {
	var menu = document.getElementById(menuid).cloneNode(false);
	if(!menu){ return null; }
	menu.id = "utloc-" + menuid;
	var menuParent = gBrowser.mStrip.firstChild.nextSibling;
	var pos = 17;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(menu);
	}else{
	  menuParent.insertBefore(menu, menuParent.childNodes[pos]);
	}
	return menu;
}

function urltablock_init() {
	urltablock_addMenuItem("urltablockmenu");
  window.addEventListener('load', urltablock_load, true);
}


function getPrefBranch(){
	if(!urltablock_pref_branch_cache){
		urltablock_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
		                           .getService(Components.interfaces.nsIPrefBranch);
	}
	return urltablock_pref_branch_cache;
}
var urltablock_pref_branch_cache = null;

function urltablock_getPrefValue(aPrefString){
	var defaultValue = urltablock_getDefaultValue(aPrefString);
	var result = defaultValue;

	try{
		switch(typeof(defaultValue)){
			case "boolean":
				result = getPrefBranch().getBoolPref(aPrefString);
				break;
			case "number":
				result = getPrefBranch().getIntPref(aPrefString);
				break;
			case "string":
				result = getPrefBranch().getComplexValue(aPrefString,
					Components.interfaces.nsISupportsString).data;
				break;
		}
	}catch(ex){
		result = defaultValue;
	}		
	return result;
}

function urltablock_getDefaultValue(aPrefString){
	switch(aPrefString){
		case "skz.urltablock.autolockurls":
			return "";
		case "skz.urltablock.tablock":
			return true;
		case "skz.urltablock.tabprotect":
			return false;
	}
	return 0;
}

function urltablock_setPrefValue(aPrefString, aPrefValue) {
	var defaultValue = urltablock_getDefaultValue(aPrefString);
  var prefBranch = getPrefBranch();

	switch(typeof(defaultValue)){
		case "boolean":
			prefBranch.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			prefBranch.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			var supportsString = Components.classes["@mozilla.org/supports-string;1"]
				.createInstance(Components.interfaces.nsISupportsString);
			supportsString.data = aPrefValue;
			prefBranch.setComplexValue(aPrefString,
				Components.interfaces.nsISupportsString, supportsString);
			break;
	}
}
